# Quorum Entropy Ceremony

This is a ceremony for generating entropy which is used to derive Quorum PGP keys, load them into smart cards and shard entropy to them. 

## Requirements

{{ #include ../../operator-requirements.md:requirements }}

* [SD Card Booster Pack](../provisioner/provision-sd-card.md)

*  `N` Smart Cards in the chosen `M of N` quorum

* [Shardfile SD Card](../provisioner/copy-shardfile-sd-card.md)

* [High Visibility Storage](TODO): plastic container or bag that's used to keep items while not in use in a visible location like the middle of a desk.

## Procedure 

1. Enter the designated location with required personnel and equipment

1. Lock access to the location - there should be no inflow or outflow of people during the ceremony

1. Retrieve Air-Gapped Bundle and polaroid tamper evidence from locked storage

### Unsealing Tamper Proofing

{{ #include ../../../../component-documents/tamper-evidence-methods.md:vsbwf-procedure-unsealing}}

1. Place all materials except for the laptop into High Visibility Storage

### Generating Entropy

1. Retrieve AirgapOS SD card from High Visibility Storage and plug it into air-gapped laptop 

1. Turn on the machine

1. Once booted, remove the AirgapOS SD card and place it into High Visibility Storage

1. Run the keyfork wizard to generate entropy, derive OpenPGP certs, load them into smart cards, and shard the secret to the generated OpenPGP keys

    * `keyfork wizard generate-shard-secret --threshold <M> --max <N> --keys-per-shard=<num_of_smart_cards_to_provision> --output shardfile.asc --cert-output keyring.asc`

        * NOT IMPLEMENTED YET

1. Unplug the Shardfile SD card and place it into High Visibility Storage

1. Open the SD Card Booster Pack, and place all cards into High Visibility Storage

1. Plug in SD cards one at a time and use following steps to back up ceremony artifacts

    1. Back up the `shardfile.asc`     

    1. Back up the `keyring.asc`
    
    1. Optionally write an `autorun.sh` file to the Shardfile SD card containing the following command:

        * `keyfork recover shard --daemon`

    1. Unplug the SD card and place it in High Visibility Storage

    1. Label the SD card "Shardfile [date]"


### Finalizing Ceremony

1. Gather all the original items that were in the air-gapped bundle:

    * Air-gapped computer

    * AirgapOS SD card

{{ #include ../../../../component-documents/tamper-evidence-methods.md:vsbwf-procedure-sealing}}